Loading...
Searching...
No Matches
casacore::MSMColumn Class Reference
tables package (libcasa_tables) » DataMan_module » DataMan_module_internal_classes

More...

`#include <MSMColumn.h>`

## Public Member Functions

| MSMColumn (MSMBase *smptr, int dataType, Bool byPtr)
| Create a column of the given type.
virtual | ~MSMColumn ()
| Frees up the storage.
| MSMColumn (const MSMColumn &)=delete
| Forbid copy constructor.
MSMColumn & | operator= (const MSMColumn &)=delete
| Forbid assignment.
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get a scalar value in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put a scalar value into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | getScalarColumnV (ArrayBase &data)
| Get all scalar values in the column.
virtual void | putScalarColumnV (const ArrayBase &data)
| Put all scalar values in the column.
virtual void | addRow (rownr_t newNrrow, rownr_t oldNrrow)
| Add (newNrrow-oldNrrow) rows to the column.
void | resize (rownr_t nrval)
| Resize the data blocks.
virtual void | remove (rownr_t rownr)
| Remove the given row.
virtual void | doCreate (rownr_t nrrow)
| Create the number of rows in a new table.
virtual void | putFile (rownr_t nrval, AipsIO &)
| Make it possible to write the column data.
virtual void | getFile (rownr_t nrval, AipsIO &)
| Make it possible to read the column data.
virtual void | reopenRW ()
| Reopen the storage manager files for read/write.
virtual Bool | ok () const
| Check if the class invariants still hold.
Public Member Functions inherited from casacore::StManColumnBase
| StManColumnBase (int dataType)
| Default constructor.
| ~StManColumnBase ()
| StManColumnBase (const StManColumnBase &)=delete
| The object cannot be copied.
StManColumnBase & | operator= (const StManColumnBase &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
DataType | dtype () const
Int | elemSize () const
| Return the size of an element of the column's data type.
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual String | dataTypeId () const
| Get the data type id of the column for dataType==TpOther.
virtual Bool | isWritable () const
| Test if data can be put into this column.
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Set the shape of an (variable-shaped) array in the given row.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Is the value shape defined in the given row?
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the item in the given row.
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the item in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
virtual Bool | canChangeShape () const
| Can the data manager handle chaging the shape of an existing array?
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
virtual void | getArrayV (rownr_t rownr, ArrayBase &dataPtr)
| Get the array value in the given row.
virtual void | putArrayV (rownr_t rownr, const ArrayBase &data)
| Put the array value into the given row.
virtual void | getArrayColumnV (ArrayBase &data)
| Get all array values in the column.
virtual void | putArrayColumnV (const ArrayBase &data)
| Put all array values in the column.
virtual void | getArrayColumnCellsV (const RefRows &rownrs, ArrayBase &data)
| Get some array values in the column.
virtual void | putArrayColumnCellsV (const RefRows &rownrs, const ArrayBase &data)
| Put some array values in the column.
virtual void | getSliceV (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
| Get a section of the array in the given row.
virtual void | putSliceV (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
| Put into a section of the array in the given row.
virtual void | getColumnSliceV (const Slicer &slicer, ArrayBase &data)
| Get a section of all arrays in the column.
virtual void | putColumnSliceV (const Slicer &slicer, const ArrayBase &data)
| Put into a section of all arrays in the column.
virtual void | getColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
| Get a section of some arrays in the column.
virtual void | putColumnSliceCellsV (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
| Put into a section of some arrays in the column.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Protected Member Functions

uInt | findExt (rownr_t rownr, Bool setCache)
| Find the extension in which the row number is.
void * | allocData (rownr_t nrval, Bool byPtr)
| Allocate an extension with the data type of the column.
void | deleteAll ()
| Delete all extensions.
void | deleteData (void *datap, Bool byPtr)
| Delete an extension.
void | removeData (void *datap, rownr_t inx, rownr_t nrvalAfter)
| Remove an entry (i.e.
virtual void | initData (void *datap, rownr_t nrval)
| Initialize the data (after an open).
void * | getArrayPtr (rownr_t rownr)
| Get the pointer for the given row.
void | putArrayPtr (rownr_t rownr, void *dataPtr)
| Put the pointer for the given row.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)

## Protected Attributes

MSMBase * | stmanPtr_p
Bool | byPtr_p
| The data is indirectly accessed via a pointer (for the derived classes).
rownr_t | nralloc_p
| The number of allocated rows in the column.
uInt | nrext_p
| The nr of extensions in use.
Block< void * > | data_p
| The assembly of all extensions (actually Block<T*>).
Block< rownr_t > | ncum_p
| The cumulative nr of rows in all extensions.

## Additional Inherited Members

Static Public Member Functions inherited from casacore::StManColumnBase
static Bool | isNativeDataType (int dtype)
| Test if the given data type is supported by storage managers.

## Detailed Description

Column in the Memory table storage manager class

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- StManColumn
- MemoryStMan

### Etymology

MSMColumn handles a column for the memory-based storage manager.

### Synopsis

MSMColumn is used by MemoryStMan to handle the access to the data in a table column. It is an storage manager based in memory. Thus the data is lost when the table is closed. On reopen it will be initialized to the default column value. It fully supports addition and removal of rows.

MSMColumn serves 2 purposes:

1. It handles a column containing scalar values.
2. It serves as a base class for MSMDirColumn and MSMIndColumn These classes handle arrays and use MSMColumn to hold a pointer to the array in each row.

MSMColumn does not hold a column as a consecutive array, because extending the column (i.e. adding rows) proved be too expensive due to the repeated copying involved when creating a table (this method was used by the first version of the table system). Instead it has a number of data blocks (extensions) indexed to by a super block. Accessing a row means finding the appropriate extension via a binary search. Because there is only 1 extension when a table is read back, the overhead in finding a row is small.

### Motivation

MSMColumn handles the standard data types. The class is not templated, but a switch statement is used instead. Templates would cause too many instantiations.

### To Do

- StManAipsIO should use this class

Definition at line 101 of file MSMColumn.h.

## Constructor & Destructor Documentation

## MSMColumn() [1/2]

casacore::MSMColumn::MSMColumn | ( | MSMBase * | smptr,
|  | int | dataType,
|  | Bool | byPtr )

Create a column of the given type.

It will maintain a pointer to its parent storage manager.

References casacore::StManColumnBase::dataType().

Referenced by MSMColumn(), and operator=().

## ~MSMColumn()

virtual casacore::MSMColumn::~MSMColumn | ( |  | ) |

virtual

Frees up the storage.

## MSMColumn() [2/2]

casacore::MSMColumn::MSMColumn | ( | const MSMColumn & |  | ) |

delete

Forbid copy constructor.

References MSMColumn().

## Member Function Documentation

## addRow()

virtual void casacore::MSMColumn::addRow | ( | rownr_t | newNrrow,
|  | rownr_t | oldNrrow )

virtual

Add (newNrrow-oldNrrow) rows to the column.

Reimplemented in casacore::MSMDirColumn, casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## allocData()

void * casacore::MSMColumn::allocData | ( | rownr_t | nrval,
|  | Bool | byPtr )

protected

Allocate an extension with the data type of the column.

## deleteAll()

void casacore::MSMColumn::deleteAll | ( |  | ) |

protected

Delete all extensions.

Possible underlying data (as used by StManArrayColumnMemory) will not be deleted and should have been deleted beforehand.

## deleteData()

void casacore::MSMColumn::deleteData | ( | void * | datap,
|  | Bool | byPtr )

protected

Delete an extension.

## doCreate()

virtual void casacore::MSMColumn::doCreate | ( | rownr_t | nrrow | ) |

virtual

Create the number of rows in a new table.

This is used when a table gets created or opened.

Reimplemented in casacore::MSMDirColumn, casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## findExt()

uInt casacore::MSMColumn::findExt | ( | rownr_t | rownr,
|  | Bool | setCache )

protected

Find the extension in which the row number is.

If the flag is true, it also sets the columnCache object.

## getArrayPtr()

void * casacore::MSMColumn::getArrayPtr | ( | rownr_t | rownr | ) |

protected

Get the pointer for the given row.

This is for the derived classes like StManArrayColumnMemory.

Referenced by casacore::MSMDirColumn::doGetSlice(), and casacore::MSMDirColumn::doPutSlice().

## getBool()

virtual void casacore::MSMColumn::getBool | ( | rownr_t | rownr,
|  | Bool * | dataPtr )

virtual

Get a scalar value in the given row.

The buffer pointed to by dataPtr has to have the correct length (which is guaranteed by the Scalar/ArrayColumn get function).

Reimplemented from casacore::DataManagerColumn.

## getComplex()

virtual void casacore::MSMColumn::getComplex | ( | rownr_t | rownr,
|  | Complex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getDComplex()

virtual void casacore::MSMColumn::getDComplex | ( | rownr_t | rownr,
|  | DComplex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getdouble()

virtual void casacore::MSMColumn::getdouble | ( | rownr_t | rownr,
|  | double * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getFile()

virtual void casacore::MSMColumn::getFile | ( | rownr_t | nrval,
|  | AipsIO & | )

virtual

Make it possible to read the column data.

It is only used by derived classes.

Reimplemented in casacore::StManColumnAipsIO, casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## getfloat()

virtual void casacore::MSMColumn::getfloat | ( | rownr_t | rownr,
|  | float * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt()

virtual void casacore::MSMColumn::getInt | ( | rownr_t | rownr,
|  | Int * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getInt64()

virtual void casacore::MSMColumn::getInt64 | ( | rownr_t | rownr,
|  | Int64 * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getScalarColumnV()

virtual void casacore::MSMColumn::getScalarColumnV | ( | ArrayBase & | data | ) |

virtual

Get all scalar values in the column.

The vector given in data has to have the correct length (which is guaranteed by the ScalarColumn getColumn function).

Reimplemented from casacore::DataManagerColumn.

## getShort()

virtual void casacore::MSMColumn::getShort | ( | rownr_t | rownr,
|  | Short * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getString()

virtual void casacore::MSMColumn::getString | ( | rownr_t | rownr,
|  | String * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuChar()

virtual void casacore::MSMColumn::getuChar | ( | rownr_t | rownr,
|  | uChar * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuInt()

virtual void casacore::MSMColumn::getuInt | ( | rownr_t | rownr,
|  | uInt * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## getuShort()

virtual void casacore::MSMColumn::getuShort | ( | rownr_t | rownr,
|  | uShort * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## initData()

virtual void casacore::MSMColumn::initData | ( | void * | datap,
|  | rownr_t | nrval )

protected virtual

Initialize the data (after an open).

Reimplemented in casacore::StManColumnAipsIO.

## ok()

virtual Bool casacore::MSMColumn::ok | ( |  | ) | const

virtual

Check if the class invariants still hold.

Reimplemented in casacore::StManColumnIndArrayAipsIO.

## operator=()

MSMColumn & casacore::MSMColumn::operator= | ( | const MSMColumn & |  | ) |

delete

Forbid assignment.

References MSMColumn().

## putArrayPtr()

void casacore::MSMColumn::putArrayPtr | ( | rownr_t | rownr,
|  | void * | dataPtr )

protected

Put the pointer for the given row.

This is for the derived classes like StManArrayColumnMemory.

## putBool()

virtual void casacore::MSMColumn::putBool | ( | rownr_t | rownr,
|  | const Bool * | dataPtr )

virtual

Put a scalar value into the given row.

The buffer pointed to by dataPtr has to have the correct length (which is guaranteed by the Scalar/ArrayColumn put function).

Reimplemented from casacore::DataManagerColumn.

## putComplex()

virtual void casacore::MSMColumn::putComplex | ( | rownr_t | rownr,
|  | const Complex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putDComplex()

virtual void casacore::MSMColumn::putDComplex | ( | rownr_t | rownr,
|  | const DComplex * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putdouble()

virtual void casacore::MSMColumn::putdouble | ( | rownr_t | rownr,
|  | const double * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putFile()

virtual void casacore::MSMColumn::putFile | ( | rownr_t | nrval,
|  | AipsIO & | )

virtual

Make it possible to write the column data.

It is only used by derived classes.

Reimplemented in casacore::StManColumnAipsIO, casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## putfloat()

virtual void casacore::MSMColumn::putfloat | ( | rownr_t | rownr,
|  | const float * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt()

virtual void casacore::MSMColumn::putInt | ( | rownr_t | rownr,
|  | const Int * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putInt64()

virtual void casacore::MSMColumn::putInt64 | ( | rownr_t | rownr,
|  | const Int64 * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putScalarColumnV()

virtual void casacore::MSMColumn::putScalarColumnV | ( | const ArrayBase & | data | ) |

virtual

Put all scalar values in the column.

The vector given in data has to have the correct length (which is guaranteed by the ScalarColumn putColumn function).

Reimplemented from casacore::DataManagerColumn.

## putShort()

virtual void casacore::MSMColumn::putShort | ( | rownr_t | rownr,
|  | const Short * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putString()

virtual void casacore::MSMColumn::putString | ( | rownr_t | rownr,
|  | const String * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuChar()

virtual void casacore::MSMColumn::putuChar | ( | rownr_t | rownr,
|  | const uChar * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuInt()

virtual void casacore::MSMColumn::putuInt | ( | rownr_t | rownr,
|  | const uInt * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## putuShort()

virtual void casacore::MSMColumn::putuShort | ( | rownr_t | rownr,
|  | const uShort * | dataPtr )

virtual

Reimplemented from casacore::DataManagerColumn.

## remove()

virtual void casacore::MSMColumn::remove | ( | rownr_t | rownr | ) |

virtual

Remove the given row.

If no rows remain in the extension, the extension is also removed.

Reimplemented in casacore::MSMDirColumn, casacore::MSMIndColumn, casacore::StManColumnArrayAipsIO, and casacore::StManColumnIndArrayAipsIO.

## removeData()

void casacore::MSMColumn::removeData | ( | void * | datap,
|  | rownr_t | inx,
|  | rownr_t | nrvalAfter )

protected

Remove an entry (i.e.

a row) from an extension at the given index. It will do this by shifting the rest (nrvalAfter elements) one position to the left.

## reopenRW()

virtual void casacore::MSMColumn::reopenRW | ( |  | ) |

virtual

Reopen the storage manager files for read/write.

Reimplemented in casacore::StManColumnIndArrayAipsIO.

## resize()

void casacore::MSMColumn::resize | ( | rownr_t | nrval | ) |

Resize the data blocks.

This adds an extension when needed.

## Member Data Documentation

## byPtr_p

Bool casacore::MSMColumn::byPtr_p

protected

The data is indirectly accessed via a pointer (for the derived classes).

Definition at line 195 of file MSMColumn.h.

## data_p

Block<void*> casacore::MSMColumn::data_p

protected

The assembly of all extensions (actually Block<T*>).

Definition at line 201 of file MSMColumn.h.

## ncum_p

Block<rownr_t> casacore::MSMColumn::ncum_p

protected

The cumulative nr of rows in all extensions.

Definition at line 203 of file MSMColumn.h.

## nralloc_p

rownr_t casacore::MSMColumn::nralloc_p

protected

The number of allocated rows in the column.

Definition at line 197 of file MSMColumn.h.

## nrext_p

uInt casacore::MSMColumn::nrext_p

protected

The nr of extensions in use.

Definition at line 199 of file MSMColumn.h.

## stmanPtr_p

MSMBase* casacore::MSMColumn::stmanPtr_p

protected

Definition at line 193 of file MSMColumn.h.

The documentation for this class was generated from the following file:

- tables/DataMan/MSMColumn.h